#![feature(asm)]
#![feature(asm_const)]
#![feature(asm_sym)]
#![feature(naked_functions)]
#![feature(panic_info_message)]

#![no_std]
#![no_main]

use ibugger_rt::entry;
use s5l87xx::Peripherals;
use nano5g::lcd::{LCD, Display};

use core::fmt::Write;

mod console;
mod panique;

entry!(main);

fn main() -> ! {
    let periphs = unsafe { Peripherals::steal() };
    let lcd = LCD::new(periphs.LCD);
    let mut display = Display::new(lcd);

    let mut console = console::Console::<{240/6}, {320/14}>::new();
    console.write_str("Hello, world!\n");
    console.blit(&mut display);
    display.flush();

    let mut i = 0;
    loop {
        core::fmt::write(&mut console, format_args!("tick {}\n", i));
        i += 1;
        console.blit(&mut display);
        display.flush();
        if i > 10 {
            break
        }
    }

    let foo: Option<i32> = None;
    foo.unwrap();

    loop {}
}
